import java.io.DataOutputStream;
import java.io.File;
import java.io.FileOutputStream;

import javax.swing.JOptionPane;

import java.io.InputStream;
import java.security.CodeSource;

import com.sun.jna.Memory;


public class Demo_ICR {

	/**
	 * @param args
	 */
	private static final int CF_DIB = 8;
	
	/* funzione per estrarre la DLL da richiamare fuori dal .jar. 
	  jna non permette di richiamare le librerie direttamente dal jar*/
	
	
	private static boolean extract_File(String fileToExtract){
		try {
			  InputStream in = Demo_ICR.class.getResourceAsStream(fileToExtract);
			  File fileOut = new File("."+fileToExtract);
			  if (fileOut.exists()){
				  System.out.println(fileToExtract+" --> exported");
			  }else
			  {
			  DataOutputStream writer = new DataOutputStream(new FileOutputStream(fileOut));
			  long oneChar = 0;
			  while((oneChar = in.read()) != -1){
			    writer.write((int)oneChar);
			  }
			  writer.close();}
			  in.close();
			} 
			catch (Exception e) {
			  e.printStackTrace();
			}
		return true;
	}
	
	
	public static void main(String[] args) {
		// TODO Auto-generated method stub 
		 
		CodeSource codeSource = Demo_ICR.class.getProtectionDomain().getCodeSource();
		try{
			String libpath = System.getProperty("jna.library.path");
		    File jarFile = new File(codeSource.getLocation().toURI().getPath());
		    String jarDir = jarFile.getParentFile().getPath();
			jarDir=jarDir+";"+libpath;
		    System.setProperty("jna.library.path", jarDir); 
		
			libpath = System.getProperty("jna.library.path");
			System.out.println("jna library path --> "+libpath);
			System.out.println("jar         path --> "+jarDir);
		}catch (Exception e) {}

		boolean creato =extract_File("/recoicr.dll");
		boolean creatoDLLREC =extract_File("/recocore.dll");
		boolean creatoREC =extract_File("/digit.rec");
		
		
		
		RecoICRAPI dlltest=RecoICRAPI.INSTANCE;
		ClpBrd dllClpbrd=ClpBrd.INSTANCE;
		
		int hwnd,hBitmap,Session;
		Memory Buffer = new Memory(512);
		String RecognizedString;
		
		
		hBitmap=0;
		//Open ICR session
		Session= dlltest.ICR_Init("demo", "demo");
		//Select Recognizer file
		dlltest.ICR_SelectRecognizer(Session,".\\digit.rec");
		
		// Check if a bitmpam is available in theclipboard
		if (dllClpbrd.IsClipboardFormatAvailable(CF_DIB))
		{
			// Open the clipboard
            dllClpbrd.OpenClipboard(0);
            // Get the DIB handle from clipboard
			hBitmap =(int) dllClpbrd.GetClipboardData(CF_DIB);
						
			int nChar= dlltest.ICR_RecognizeLine(Session, hBitmap, 0);
			//Close the Clipboard
			 dllClpbrd.CloseClipboard();

			if (nChar>0) {
				
					nChar = dlltest.ICR_GetResultValue(Session, Buffer);//RecognizedString
					RecognizedString=Buffer.getString(0); 
					JOptionPane.showMessageDialog(null, RecognizedString);
			}
			else JOptionPane.showMessageDialog(null, "No data recognized !" );
		}
		else
			JOptionPane.showMessageDialog(null, "Unable to paste DIB");
		
		//Close ICR Session
		dlltest.ICR_Done(Session);
					
		
	}

}
